<?php
//-------------------------------------------------------------------
// Define your id.
//-------------------------------------------------------------------
// user id information
define("ACCESS_KEY_ID"     , 'Your Access id.     '                    );
define("SECRET_ACCESS_KEY" , 'Your Secret Access id.                  ');
define("ASSOCIATE_TAG"     , 'Your Associate id.'                      );

// access url(Jpanan)
define("ACCESS_URL"        , 'http://ecs.amazonaws.jp/onca/xml'        );
//	define("ACCESS_URL", 'https://aws.amazonaws.jp/onca/xml');
//-------------------------------------------------------------------


//-------------------------------------------------------------------
// this function is encode with RFC3986 format.
//-------------------------------------------------------------------
function urlencode_RFC3986($str)
{
    return str_replace('%7E', '~', rawurlencode($str));
}


//-------------------------------------------------------------------
// Main routine.
//-------------------------------------------------------------------
$base_param = 'AWSAccessKeyId='.ACCESS_KEY_ID;

$params = array();

$params['Service']        = 'AWSECommerceService';
$params['Version']        = '2009-10-01';
$params['Operation']      = 'ItemSearch';

$params['SearchIndex']    = 'Software';  
$params['Sort']           = 'salesrank';  

$params['Keywords']       = 'Windows';        // search key ( UTF-8 )
$params['AssociateTag']   = ASSOCIATE_TAG;

$params['ResponseGroup']  = 'ItemAttributes,Offers, Images ,Reviews ';

$params['SignatureMethod']  = 'HmacSHA256';   // signature format name.
$params['SignatureVersion'] = 2;              // signature version.

  // time zone (ISO8601 format)
$params['Timestamp']      = gmdate('Y-m-d\TH:i:s\Z'); 

// sort $param by asc.
ksort($params);

// create canonical string.
$canonical_string = $base_param;
foreach ($params as $k => $v) {
    $canonical_string .= '&'.urlencode_RFC3986($k).'='.urlencode_RFC3986($v);
}

// create signature strings.( HMAC-SHA256 & BASE64 )
$parsed_url = parse_url(ACCESS_URL);
$string_to_sign = "GET\n{$parsed_url['host']}\n{$parsed_url['path']}\n{$canonical_string}";

$signature = base64_encode(
					hash_hmac('sha256', $string_to_sign, SECRET_ACCESS_KEY, true)
				);

// create URL strings.
$url = ACCESS_URL.'?'.$canonical_string.'&Signature='.urlencode_RFC3986($signature);

// request to amazon !!
$response = file_get_contents($url);

// response to strings.
$parsed_xml = null;
if(isset($response)){
	$parsed_xml = simplexml_load_string($response);
}

$err_count=0;

// print out of response.
if( $response && 
    isset($parsed_xml) && 
    !$parsed_xml->faultstring &&
    !$parsed_xml->Items->Request->Errors  ){

	// total results num.
	$total_results = $parsed_xml->Items->TotalResults;
	// total results pages.
	$total_pages = $parsed_xml->Items->TotalPages;
	
	print("All Result Count:".$total_results."  | Pages :".$total_pages );

	print("<table>");
	foreach($parsed_xml->Items->Item as $current){
		$nerr=0;
		
		print("<tr><td><font size='-1'>");
		
		print('<a href="'.$current->DetailPageURL.'"><img src="'.$current->SmallImage->URL.'" border=0></a><br >');
		print('<a href="'.$current->DetailPageURL.'">'.$current->ItemAttributes->Title.'</a><br />');
		print($current->ItemAttributes->Manufacturer.'<br />');

		if(isset($current->Offers) && isset($current->Offers->Offer)){
			print( $current->Offers->Offer->OfferListing->Price->FormattedPrice.'<br />');
		} else {
			print($current->ItemAttributes->ListPrice->FormattedPrice.'<br />');
		}
		if(isset($current->CustomerReviews->TotalReviews) && $current->CustomerReviews->TotalReviews>0){
			print('Rate:<a href="'.$current->ItemLinks->ItemLink[2]->URL.'">');
			print($current->CustomerReviews->AverageRating.'('. $current->CustomerReviews->TotalReviews .')'.'<br />');
			print('</a><hr />');
		}
		print("</td></tr>");
	}
	print("</table>");
}
?>
